# DpwFeedbackWidget

This library was generated with [Angular CLI](https://github.com/angular/angular-cli) version 12.2.0.

## Installation

1. Install package from `npm`.

```sh
npm install dpw-feedback-widget --save
```

2. Include `DpwFeedbackWidgetModule` into your application.

```ts
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { DpwFeedbackWidgetModule } from 'dpw-feedback-widget';

@NgModule({
  imports: [BrowserModule, DpwFeedbackWidgetModule],
  declarations: [AppComponent],
  bootstrap: [AppComponent]
})
export class AppModule {}
```
3. Reference the assets of the libary in `angular.json` file.

```json
{
  "build": {
    "options": {
      "assets": [
        {
          "glob": "**/*",
          "input": "./node_modules/dpw-feedback-widget/assets",
          "output": "/assets/"
        }
      ]
    }
  }
}

```

4. your.template.html

```html
<dpw-feedback-widget
  [widgetName]=""
  [productName]=""
  [userEmail]="abc@example.com"
  [isLoggedIn]="false"
  [heading]="Share Your Feedback"
  [description]="How would you rate your experience?"
  [ratingStyle]="smiley"
  (onClose)="onFeedbackClose()"
  [thankYouHeading]="Thank You!"
  [thankYouDescription]="We appriciate your feedback and response. Looking forward to serve you again."
>
</dpw-feedback-widget>
```
5. Optional input properties with their default values

```ts
@Input() width: string; // To customise popup width
@Input() height: string; // To customise popup height
@Input() feedbackBtnText: string; // Default - "Submit Feedback"
@Input() thankYouBtnText: string; // Default - "Done"
@Input() showClose: boolean; // Default - true
@Input() enableProgressive: boolean;
@Input() progressiveChips: string[];
@Input() badRatingHeader: string; // Default - "What went wrong?"
@Input() averageRatingHeader: string; // Default - "What went well?"
@Input() goodRatingHeader: string; // Default - "What went well?"
@Output() onSuccess = new EventEmitter(); // Get called from thank you screen
@Input() textareaLimit: number; // Default - 250
```
## Further help

To get more help on the Angular CLI use `ng help` or go check out the [Angular CLI Overview and Command Reference](https://angular.io/cli) page.
