(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/common/http'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('dpw-feedback-widget', ['exports', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/common/http', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["dpw-feedback-widget"] = {}, global.ng.core, global.rxjs, global.rxjs.operators, global.ng.common.http, global.ng.common));
})(this, (function (exports, i0, rxjs, operators, i1, i5) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i5__namespace = /*#__PURE__*/_interopNamespace(i5);

    var initialState = {
        ratingInfo: null,
        chips: [],
        progressiveFeedbackData: null
    };
    var DpwFeedbackWidgetService = /** @class */ (function () {
        function DpwFeedbackWidgetService(http) {
            this.http = http;
            this.hasError = false;
            this.metaData = {};
            this.userFeedback = new rxjs.BehaviorSubject(initialState);
            this.userFeedback$ = this.userFeedback.asObservable();
            this.ratingInfo$ = this.userFeedback$.pipe(operators.map(function (state) { return state.ratingInfo; }), operators.distinctUntilChanged());
        }
        Object.defineProperty(DpwFeedbackWidgetService.prototype, "currentState", {
            get: function () {
                return this.userFeedback.getValue();
            },
            enumerable: false,
            configurable: true
        });
        DpwFeedbackWidgetService.prototype.updateMetaData = function (data) {
            this.metaData = Object.assign(Object.assign({}, this.metaData), data);
        };
        DpwFeedbackWidgetService.prototype.updateUserFeedback = function (data) {
            this.userFeedback.next(Object.assign(Object.assign({}, this.currentState), data));
        };
        DpwFeedbackWidgetService.prototype.resetState = function () {
            this.userFeedback.next(initialState);
        };
        DpwFeedbackWidgetService.prototype.submitFeedback = function (reqBody) {
            return this.http.post('http://localhost:3600/api/feedback/users', reqBody);
        };
        return DpwFeedbackWidgetService;
    }());
    DpwFeedbackWidgetService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: DpwFeedbackWidgetService, deps: [{ token: i1__namespace.HttpClient }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    DpwFeedbackWidgetService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: DpwFeedbackWidgetService, providedIn: "root" });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: DpwFeedbackWidgetService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: "root",
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace.HttpClient }]; } });

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (g && (g = 0, op[0] && (_ = 0)), _)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        var desc = Object.getOwnPropertyDescriptor(m, k);
        if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
            desc = { enumerable: true, get: function () { return m[k]; } };
        }
        Object.defineProperty(o, k2, desc);
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }
    function __classPrivateFieldIn(state, receiver) {
        if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function"))
            throw new TypeError("Cannot use 'in' operator on non-object");
        return typeof state === "function" ? receiver === state : state.has(receiver);
    }

    var noop = function () { };
    function isRequired(requiredType, size) {
        return function (target, prop) {
            var NG_ON_ONIT_NAME = "ngOnInit";
            /** ngOnInit might not be implemented by this component */
            var ngOnInitClone = target[NG_ON_ONIT_NAME];
            Object.defineProperty(target, NG_ON_ONIT_NAME, {
                value: function () {
                    if (this[prop] == null) {
                        throw new Error(target.constructor.name +
                            (": @Input " + prop + " is required, but was not provided"));
                    }
                    else if (requiredType && typeof this[prop] !== requiredType) {
                        throw new Error(target.constructor.name +
                            (": @Input " + prop + " is expected to be a " + requiredType + ", but " + typeof this[prop] + " was provided"));
                    }
                    else if (size &&
                        typeof this[prop] === "string" &&
                        this[prop].length > size) {
                        throw new Error(target.constructor.name +
                            (": @Input '" + prop + "' can't be more than " + size + " characters"));
                    }
                    // Calling the original ngOnInit with its original context
                    (ngOnInitClone || noop).call(this);
                },
            });
        };
    }

    function isTypeOf(requiredType, limit) {
        return function (target, prop, newVal) {
            /** Whether the new value matches the required type */
            var isValidType = true;
            if (newVal) {
                if (requiredType === "array") {
                    isValidType = newVal instanceof Array;
                }
                else {
                    isValidType = typeof newVal === requiredType;
                }
                if (!isValidType) {
                    throw new Error(target.constructor.name +
                        (": @Input '" + prop + "' is expected to be of type " + requiredType + ", but type " + typeof newVal + " was provided"));
                }
            }
            if (limit && typeof newVal === "string" && newVal.length > limit) {
                throw new Error(target.constructor.name +
                    (": @Input '" + prop + "' can't be more than " + limit + " characters"));
            }
            else if (limit && newVal instanceof Array && newVal.length > limit) {
                throw new Error(target.constructor.name +
                    (": @Input '" + prop + "' length can't be more than " + limit));
            }
        };
    }

    function validateAgainst(fn) {
        return function (target, prop) {
            var _value = null;
            // Create new property with getter and setter
            Object.defineProperty(target, prop, {
                get: function () {
                    return _value;
                },
                set: function (newVal) {
                    _value = newVal;
                    fn(target, prop, newVal);
                },
                configurable: true,
                enumerable: true,
            });
        };
    }

    var RATING_TYPE = {
        GOOD: "GOOD",
        AVERAGE: "AVERAGE",
        BAD: "BAD",
    };
    var DEFAULT_FEEDBACK_META_DATA = {
        feedbackBtnText: "Submit Feedback",
        showClose: true,
        thankYouHeading: "Thank You!",
        thankYouDescription: "We appriciate your feedback and response. Looking forward to serve you again.",
        thankYouBtnText: "Done",
        badRatingHeader: "What went wrong?",
        averageRatingHeader: "What went well?",
        goodRatingHeader: "What went well?",
        closeHandler: null,
        onSubmitFeedback: null,
        textareaLimit: 250,
    };
    var SMILEY_RATINGS = [
        {
            rating: 1,
            title: "Terrible",
            imgUrl: "assets/images/fw_terribleEmoji.svg",
            type: RATING_TYPE.BAD,
        },
        {
            rating: 2,
            title: "Bad",
            imgUrl: "assets/images/fw_badEmoji.svg",
            type: RATING_TYPE.BAD,
        },
        {
            rating: 3,
            title: "Okay",
            imgUrl: "assets/images/fw_okayEmoji.svg",
            type: RATING_TYPE.AVERAGE,
        },
        {
            rating: 4,
            title: "Good",
            imgUrl: "assets/images/fw_goodEmoji.svg",
            type: RATING_TYPE.GOOD,
        },
        {
            rating: 5,
            title: "Amazing",
            imgUrl: "assets/images/fw_amazingEmoji.svg",
            type: RATING_TYPE.GOOD,
        },
    ];
    var STAR_RATINGS = [
        {
            rating: 1,
            title: "Very Bad",
            imgUrl: "assets/images/fw_terribleEmoji.svg",
            type: RATING_TYPE.BAD,
        },
        {
            rating: 2,
            title: "Bad",
            imgUrl: "assets/images/fw_badEmoji.svg",
            type: RATING_TYPE.BAD,
        },
        {
            rating: 3,
            title: "Okay",
            imgUrl: "assets/images/fw_okayEmoji.svg",
            type: RATING_TYPE.AVERAGE,
        },
        {
            rating: 4,
            title: "Good",
            imgUrl: "assets/images/fw_goodEmoji.svg",
            type: RATING_TYPE.GOOD,
        },
        {
            rating: 5,
            title: "Excellent",
            imgUrl: "assets/images/fw_amazingEmoji.svg",
            type: RATING_TYPE.GOOD,
        },
    ];

    var FeedbackWidgetHeaderComponent = /** @class */ (function () {
        function FeedbackWidgetHeaderComponent(fwService) {
            this.fwService = fwService;
        }
        FeedbackWidgetHeaderComponent.prototype.ngOnInit = function () { };
        return FeedbackWidgetHeaderComponent;
    }());
    FeedbackWidgetHeaderComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: FeedbackWidgetHeaderComponent, deps: [{ token: DpwFeedbackWidgetService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    FeedbackWidgetHeaderComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: FeedbackWidgetHeaderComponent, selector: "lib-feedback-widget-header", ngImport: i0__namespace, template: "<div class=\"fw-header-container\">\n  <p class=\"fw-header\">{{ fwService.metaData.header }}</p>\n  <p class=\"fw-sub-header\">{{ fwService.metaData.subHeader }}</p>\n  <img *ngIf=\"fwService.metaData.showClose\" class=\"fw-close-icon\" (click)=\"fwService.metaData.closeHandler()\" src=\"assets/images/fw_close_icon.svg\" />\n</div>\n", styles: [":host .fw-header-container .fw-header{font-weight:700;font-size:24px;line-height:33px}:host .fw-header-container .fw-sub-header{font-weight:400;font-size:15px;line-height:21px}:host .fw-header-container .fw-close-icon{position:absolute;top:10px;right:10px;width:21px;height:21px;cursor:pointer}\n"], directives: [{ type: i5__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: FeedbackWidgetHeaderComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: "lib-feedback-widget-header",
                        templateUrl: "./feedback-widget-header.component.html",
                        styleUrls: ["./feedback-widget-header.component.scss"],
                    }]
            }], ctorParameters: function () { return [{ type: DpwFeedbackWidgetService }]; } });

    var ProgressiveRatingComponent = /** @class */ (function () {
        function ProgressiveRatingComponent(fwService) {
            this.fwService = fwService;
        }
        ProgressiveRatingComponent.prototype.ngOnInit = function () { };
        ProgressiveRatingComponent.prototype.onSelectChip = function (item) {
            var chips = this.fwService.currentState.chips;
            var index = chips.indexOf(item);
            var newChips = [];
            if (index === -1) {
                newChips = __spreadArray(__spreadArray([], __read(chips)), [item]);
            }
            else {
                newChips = chips.filter(function (chip) { return chip !== item; });
            }
            this.fwService.updateUserFeedback({ chips: newChips });
        };
        ProgressiveRatingComponent.prototype.getHeader = function () {
            var type = this.fwService.currentState.ratingInfo.type;
            var _a = this.fwService.metaData, badRatingHeader = _a.badRatingHeader, averageRatingHeader = _a.averageRatingHeader, goodRatingHeader = _a.goodRatingHeader;
            switch (type) {
                case RATING_TYPE.GOOD:
                    return goodRatingHeader;
                case RATING_TYPE.AVERAGE:
                    return averageRatingHeader;
                case RATING_TYPE.BAD:
                    return badRatingHeader;
                default:
                    return "";
            }
        };
        ProgressiveRatingComponent.prototype.onFeedbackText = function (progressiveFeedbackData) {
            this.fwService.updateUserFeedback({ progressiveFeedbackData: progressiveFeedbackData });
        };
        return ProgressiveRatingComponent;
    }());
    ProgressiveRatingComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: ProgressiveRatingComponent, deps: [{ token: DpwFeedbackWidgetService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    ProgressiveRatingComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: ProgressiveRatingComponent, selector: "lib-progressive-rating", ngImport: i0__namespace, template: "<div class=\"fw-progressive-rating\">\n  <p class=\"fw-header\">{{ getHeader() }}</p>\n  <div\n    class=\"fw-chips-container\"\n    *ngIf=\"fwService.metaData?.progressiveChips?.length\"\n  >\n    <div\n      class=\"fw-chip-item\"\n      [ngClass]=\"{ 'fw-active': fwService.currentState.chips.includes(item) }\"\n      *ngFor=\"let item of fwService.metaData.progressiveChips\"\n      (click)=\"onSelectChip(item)\"\n    >\n      {{ item }}\n    </div>\n  </div>\n  <div\n    class=\"fw-textarea\"\n    *ngIf=\"!fwService.metaData?.progressiveChips?.length\"\n  >\n    <textarea\n      rows=\"4\"\n      cols=\"100\"\n      placeholder=\"Tell us more (optional)\"\n      [maxLength]=\"fwService.metaData.textareaLimit\"\n      [value]=\"fwService.currentState.progressiveFeedbackData\"\n      (change)=\"onFeedbackText($event.target.value)\"\n    ></textarea>\n  </div>\n</div>\n", styles: [":host .fw-progressive-rating{margin:40px 0}:host .fw-progressive-rating .fw-header{font-weight:700;font-size:18px;line-height:24px;margin:0}:host .fw-progressive-rating .fw-chips-container{display:flex;flex-wrap:wrap;justify-content:space-between}:host .fw-progressive-rating .fw-chip-item{padding:15px 20px;font-size:15px;font-weight:700;border:1px solid #6a6a6d;border-radius:3px;cursor:pointer;width:calc(50% - 7.5px);box-sizing:border-box;margin-top:15px}:host .fw-progressive-rating .fw-chip-item.fw-active{background:#e3f2fd;color:#007ba8;border:1px solid #0b78d0}:host .fw-progressive-rating .fw-textarea{display:flex;margin-top:20px}:host .fw-progressive-rating .fw-textarea textarea{border:1px solid #6a6a6d;border-radius:3px;padding:10px;resize:none}\n"], directives: [{ type: i5__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i5__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: ProgressiveRatingComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: "lib-progressive-rating",
                        templateUrl: "./progressive-rating.component.html",
                        styleUrls: ["./progressive-rating.component.scss"],
                    }]
            }], ctorParameters: function () { return [{ type: DpwFeedbackWidgetService }]; } });

    var FeedbackWidgetFooterComponent = /** @class */ (function () {
        function FeedbackWidgetFooterComponent(fwService) {
            this.fwService = fwService;
        }
        FeedbackWidgetFooterComponent.prototype.ngOnInit = function () { };
        return FeedbackWidgetFooterComponent;
    }());
    FeedbackWidgetFooterComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: FeedbackWidgetFooterComponent, deps: [{ token: DpwFeedbackWidgetService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    FeedbackWidgetFooterComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: FeedbackWidgetFooterComponent, selector: "lib-feedback-widget-footer", inputs: { fullWidth: "fullWidth", disabled: "disabled" }, ngImport: i0__namespace, template: "<div class=\"fw-footer-container\">\n  <button class=\"fw-submit-btn\" [ngClass]=\"{'fw-fullWidth': fullWidth, 'fw-disable': disabled, 'fw-active': !disabled}\" (click)=\"!disabled && fwService.metaData.onSubmitFeedback()\">{{ fwService.metaData.feedbackBtnText }}</button>\n</div>\n", styles: [":host .fw-footer-container{display:flex;align-items:center;justify-content:flex-end}:host .fw-footer-container .fw-submit-btn{width:200px;height:40px;border-radius:3px;font-weight:700;font-size:12px;line-height:21px;text-align:center;text-transform:uppercase;color:#fff;cursor:pointer}:host .fw-footer-container .fw-submit-btn.fw-active{background:#0b78d0;border:3px solid #0b78d0}:host .fw-footer-container .fw-submit-btn.fw-disable{background:#bebec1;border:3px solid #bebec1;cursor:not-allowed}:host .fw-footer-container .fw-submit-btn.fw-fullWidth{width:100%}\n"], directives: [{ type: i5__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: FeedbackWidgetFooterComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: "lib-feedback-widget-footer",
                        templateUrl: "./feedback-widget-footer.component.html",
                        styleUrls: ["./feedback-widget-footer.component.scss"],
                    }]
            }], ctorParameters: function () { return [{ type: DpwFeedbackWidgetService }]; }, propDecorators: { fullWidth: [{
                    type: i0.Input
                }], disabled: [{
                    type: i0.Input
                }] } });

    var StarFeedbackWidgetComponent = /** @class */ (function () {
        function StarFeedbackWidgetComponent(fwService) {
            this.fwService = fwService;
            this.ratingArr = STAR_RATINGS;
            this.starIcon = "assets/images/fw_starIcon.svg";
            this.starIconYellow = "assets/images/fw_starIconYellow.svg";
        }
        StarFeedbackWidgetComponent.prototype.ngOnInit = function () { };
        StarFeedbackWidgetComponent.prototype.onSelect = function (ratingInfo) {
            this.fwService.updateUserFeedback({ ratingInfo: ratingInfo });
        };
        return StarFeedbackWidgetComponent;
    }());
    StarFeedbackWidgetComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: StarFeedbackWidgetComponent, deps: [{ token: DpwFeedbackWidgetService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    StarFeedbackWidgetComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: StarFeedbackWidgetComponent, selector: "app-star-feedback-widget", ngImport: i0__namespace, template: "<div class=\"fw-dialog-container\" [style.width]=\"fwService.metaData.width\" [style.height]=\"fwService.metaData.height\">\n    <lib-feedback-widget-header></lib-feedback-widget-header>\n    <div class=\"fw-rating-container\">\n        <div class=\"fw-rating\" *ngFor=\"let item of ratingArr\" (click)=\"onSelect(item)\">\n            <img [src]=\"fwService.currentState.ratingInfo?.rating >= item.rating ? starIconYellow : starIcon\" />\n        </div>\n    </div>\n    <div class=\"fw-rating-info\" [hidden]=\"!fwService.currentState.ratingInfo\">\n        <img [src]=\"fwService.currentState.ratingInfo?.imgUrl\" />\n        <span [ngClass]=\"{'fw-green': fwService.currentState.ratingInfo?.rating > 2, 'fw-red': fwService.currentState.ratingInfo?.rating < 3}\">{{ fwService.currentState.ratingInfo?.title }}</span>\n    </div>\n    <lib-progressive-rating *ngIf=\"fwService.metaData.enableProgressive && fwService.currentState.ratingInfo\"></lib-progressive-rating>\n    <lib-feedback-widget-footer [fullWidth]=\"true\" [disabled]=\"!fwService.currentState.ratingInfo\"></lib-feedback-widget-footer>\n</div>\n", styles: [":host .fw-dialog-container{width:500px}:host .fw-dialog-container .fw-rating-container{display:flex;justify-content:space-between;margin:40px 0}:host .fw-dialog-container .fw-rating-container .fw-rating{display:flex;flex-direction:column;align-items:center;justify-content:center;cursor:pointer}:host .fw-dialog-container .fw-rating-container .fw-rating img{width:40px;height:38px}:host .fw-dialog-container .fw-rating-info{display:flex;align-items:center;justify-content:center;margin:40px 0}:host .fw-dialog-container .fw-rating-info span{margin-left:10px;font-weight:700;font-size:15px;line-height:21px}:host .fw-dialog-container .fw-rating-info span.fw-green{color:#5fb25c}:host .fw-dialog-container .fw-rating-info span.fw-red{color:#e53935}\n"], components: [{ type: FeedbackWidgetHeaderComponent, selector: "lib-feedback-widget-header" }, { type: ProgressiveRatingComponent, selector: "lib-progressive-rating" }, { type: FeedbackWidgetFooterComponent, selector: "lib-feedback-widget-footer", inputs: ["fullWidth", "disabled"] }], directives: [{ type: i5__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i5__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i5__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: StarFeedbackWidgetComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: "app-star-feedback-widget",
                        templateUrl: "./star-feedback-widget.component.html",
                        styleUrls: ["./star-feedback-widget.component.scss"],
                    }]
            }], ctorParameters: function () { return [{ type: DpwFeedbackWidgetService }]; } });

    var SmileyFeedbackWidgetComponent = /** @class */ (function () {
        function SmileyFeedbackWidgetComponent(fwService) {
            this.fwService = fwService;
            this.ratingArr = SMILEY_RATINGS;
        }
        SmileyFeedbackWidgetComponent.prototype.ngOnInit = function () { };
        SmileyFeedbackWidgetComponent.prototype.onSelect = function (ratingInfo) {
            this.fwService.updateUserFeedback({ ratingInfo: ratingInfo });
        };
        return SmileyFeedbackWidgetComponent;
    }());
    SmileyFeedbackWidgetComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SmileyFeedbackWidgetComponent, deps: [{ token: DpwFeedbackWidgetService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    SmileyFeedbackWidgetComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: SmileyFeedbackWidgetComponent, selector: "app-smiley-feedback-widget", ngImport: i0__namespace, template: "<div class=\"fw-dialog-container\" [style.width]=\"fwService.metaData.width\" [style.height]=\"fwService.metaData.height\">\n    <lib-feedback-widget-header></lib-feedback-widget-header>\n    <div class=\"fw-rating-container\">\n        <div class=\"fw-rating\" *ngFor=\"let item of ratingArr\" [ngClass]=\"{'fw-active': fwService.currentState.ratingInfo?.title === item.title }\" (click)=\"onSelect(item)\">\n            <img [src]=\"item.imgUrl\" />\n            <label>{{item.title}}</label>\n        </div>\n    </div>\n    <lib-progressive-rating *ngIf=\"fwService.metaData.enableProgressive && fwService.currentState.ratingInfo\"></lib-progressive-rating>\n    <lib-feedback-widget-footer [disabled]=\"!fwService.currentState.ratingInfo\"></lib-feedback-widget-footer>\n</div>\n", styles: [":host .fw-dialog-container{width:650px}:host .fw-dialog-container .fw-rating-container{display:flex;justify-content:space-between;margin:40px 0}:host .fw-dialog-container .fw-rating-container .fw-rating{border:1px solid #6a6a6d;border-radius:3px;text-align:center;width:100px;height:100px;display:flex;flex-direction:column;align-items:center;justify-content:center;cursor:pointer}:host .fw-dialog-container .fw-rating-container .fw-rating img{width:30px;height:30px}:host .fw-dialog-container .fw-rating-container .fw-rating label{margin-top:10px;cursor:pointer}:host .fw-dialog-container .fw-rating-container .fw-rating.fw-active,:host .fw-dialog-container .fw-rating-container .fw-rating:hover{background:#e3f2fd;border:1px solid #0b78d0}\n"], components: [{ type: FeedbackWidgetHeaderComponent, selector: "lib-feedback-widget-header" }, { type: ProgressiveRatingComponent, selector: "lib-progressive-rating" }, { type: FeedbackWidgetFooterComponent, selector: "lib-feedback-widget-footer", inputs: ["fullWidth", "disabled"] }], directives: [{ type: i5__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i5__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i5__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SmileyFeedbackWidgetComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: "app-smiley-feedback-widget",
                        templateUrl: "./smiley-feedback-widget.component.html",
                        styleUrls: ["./smiley-feedback-widget.component.scss"],
                    }]
            }], ctorParameters: function () { return [{ type: DpwFeedbackWidgetService }]; } });

    var FeedbackWidgetThankyouComponent = /** @class */ (function () {
        function FeedbackWidgetThankyouComponent(fwService) {
            this.fwService = fwService;
        }
        FeedbackWidgetThankyouComponent.prototype.ngOnInit = function () { };
        FeedbackWidgetThankyouComponent.prototype.onDone = function () {
            this.fwService.metaData.closeHandler();
            this.fwService.metaData.successHandler();
        };
        return FeedbackWidgetThankyouComponent;
    }());
    FeedbackWidgetThankyouComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: FeedbackWidgetThankyouComponent, deps: [{ token: DpwFeedbackWidgetService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    FeedbackWidgetThankyouComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: FeedbackWidgetThankyouComponent, selector: "lib-feedback-widget-thankyou", ngImport: i0__namespace, template: "<div class=\"fw-dialog-container\">\n  <p class=\"fw-header\">\n    <img src=\"assets/images/fw_greenTick.svg\" />\n    {{ fwService.metaData.thankYouHeading }}\n  </p>\n  <p class=\"fw-sub-header\">{{ fwService.metaData.thankYouDescription }}</p>\n  <img\n    *ngIf=\"fwService.metaData.showClose\"\n    class=\"fw-close-icon\"\n    (click)=\"fwService.metaData.closeHandler()\"\n    src=\"assets/images/fw_close_icon.svg\"\n  />\n  <div class=\"fw-footer-container\">\n    <button class=\"fw-submit-btn fw-active\" (click)=\"onDone()\">{{ fwService.metaData.thankYouBtnText }}</button>\n  </div>\n</div>\n", styles: [":host .fw-dialog-container{max-height:400px;width:400px}:host .fw-dialog-container .fw-header{font-weight:700;font-size:24px;line-height:33px;color:#5fb25c;display:flex;align-items:center}:host .fw-dialog-container .fw-header img{margin-right:15px}:host .fw-dialog-container .fw-sub-header{font-weight:400;font-size:15px;line-height:21px}:host .fw-dialog-container .fw-close-icon{position:absolute;top:10px;right:10px;width:21px;height:21px;cursor:pointer}:host .fw-dialog-container .fw-footer-container{display:flex;align-items:center;justify-content:flex-end;margin-top:40px}:host .fw-dialog-container .fw-footer-container .fw-submit-btn{width:125px;height:40px;border-radius:3px;font-weight:700;font-size:12px;line-height:21px;text-align:center;text-transform:uppercase;color:#fff;cursor:pointer}:host .fw-dialog-container .fw-footer-container .fw-submit-btn.fw-active{background:#0b78d0;border:3px solid #0b78d0}\n"], directives: [{ type: i5__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: FeedbackWidgetThankyouComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: "lib-feedback-widget-thankyou",
                        templateUrl: "./feedback-widget-thankyou.component.html",
                        styleUrls: ["./feedback-widget-thankyou.component.scss"],
                    }]
            }], ctorParameters: function () { return [{ type: DpwFeedbackWidgetService }]; } });

    var DpwFeedbackWidgetComponent = /** @class */ (function () {
        function DpwFeedbackWidgetComponent(fwService) {
            var _this = this;
            this.fwService = fwService;
            this.feedbackBtnText = DEFAULT_FEEDBACK_META_DATA.feedbackBtnText;
            this.showClose = DEFAULT_FEEDBACK_META_DATA.showClose;
            this.thankYouBtnText = DEFAULT_FEEDBACK_META_DATA.thankYouBtnText;
            this.badRatingHeader = DEFAULT_FEEDBACK_META_DATA.badRatingHeader;
            this.averageRatingHeader = DEFAULT_FEEDBACK_META_DATA.averageRatingHeader;
            this.goodRatingHeader = DEFAULT_FEEDBACK_META_DATA.goodRatingHeader;
            this.onClose = new i0.EventEmitter();
            this.onSuccess = new i0.EventEmitter();
            this.textareaLimit = DEFAULT_FEEDBACK_META_DATA.textareaLimit;
            this.feedbackSubmitted = false;
            this.closeHandler = function () {
                _this.onClose.emit();
            };
            this.successHandler = function () {
                _this.onSuccess.emit();
            };
            this.onSubmitFeedback = function () {
                var _a = _this.fwService.currentState, ratingInfo = _a.ratingInfo, progressiveFeedbackData = _a.progressiveFeedbackData, chips = _a.chips;
                var data = {
                    userEmail: _this.userEmail || "",
                    isUserLoggedOut: _this.isLoggedIn,
                    ratingScore: ratingInfo.rating,
                    progessiveChipsSelected: chips && chips.length ? JSON.stringify(chips) : null,
                    progressiveFeedbackData: progressiveFeedbackData,
                };
                console.log("sourabh data: ", data);
                // this.fwService.submitFeedback(data).subscribe((res) => {
                //   this.feedbackSubmitted = true;
                // });
                _this.feedbackSubmitted = true;
            };
        }
        DpwFeedbackWidgetComponent.prototype.ngOnInit = function () {
            var _a = this, width = _a.width, height = _a.height, widgetName = _a.widgetName, productName = _a.productName, heading = _a.heading, description = _a.description, ratingStyle = _a.ratingStyle, feedbackBtnText = _a.feedbackBtnText, showClose = _a.showClose, thankYouHeading = _a.thankYouHeading, thankYouDescription = _a.thankYouDescription, thankYouBtnText = _a.thankYouBtnText, enableProgressive = _a.enableProgressive, progressiveChips = _a.progressiveChips, badRatingHeader = _a.badRatingHeader, averageRatingHeader = _a.averageRatingHeader, goodRatingHeader = _a.goodRatingHeader, isLoggedIn = _a.isLoggedIn, textareaLimit = _a.textareaLimit, closeHandler = _a.closeHandler, onSubmitFeedback = _a.onSubmitFeedback, successHandler = _a.successHandler;
            this.fwService.updateMetaData({
                width: width,
                height: height,
                widgetName: widgetName,
                productName: productName,
                header: heading,
                subHeader: description,
                ratingStyle: ratingStyle,
                feedbackBtnText: feedbackBtnText,
                showClose: showClose,
                thankYouHeading: thankYouHeading,
                thankYouDescription: thankYouDescription,
                thankYouBtnText: thankYouBtnText,
                enableProgressive: isLoggedIn && enableProgressive,
                progressiveChips: progressiveChips,
                badRatingHeader: badRatingHeader,
                averageRatingHeader: averageRatingHeader,
                goodRatingHeader: goodRatingHeader,
                textareaLimit: textareaLimit,
                closeHandler: closeHandler,
                onSubmitFeedback: onSubmitFeedback,
                successHandler: successHandler,
            });
        };
        DpwFeedbackWidgetComponent.prototype.ngOnDestroy = function () {
            this.fwService.resetState();
        };
        return DpwFeedbackWidgetComponent;
    }());
    DpwFeedbackWidgetComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: DpwFeedbackWidgetComponent, deps: [{ token: DpwFeedbackWidgetService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    DpwFeedbackWidgetComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: DpwFeedbackWidgetComponent, selector: "dpw-feedback-widget", inputs: { width: "width", height: "height", widgetName: "widgetName", productName: "productName", heading: "heading", description: "description", ratingStyle: "ratingStyle", userEmail: "userEmail", isLoggedIn: "isLoggedIn", feedbackBtnText: "feedbackBtnText", showClose: "showClose", thankYouHeading: "thankYouHeading", thankYouDescription: "thankYouDescription", thankYouBtnText: "thankYouBtnText", enableProgressive: "enableProgressive", progressiveChips: "progressiveChips", badRatingHeader: "badRatingHeader", averageRatingHeader: "averageRatingHeader", goodRatingHeader: "goodRatingHeader", textareaLimit: "textareaLimit" }, outputs: { onClose: "onClose", onSuccess: "onSuccess" }, ngImport: i0__namespace, template: "<div class=\"feedback-widget-container\" *ngIf=\"!fwService.hasError\">\n  <ng-container\n    [ngSwitch]=\"ratingStyle.toUpperCase()\"\n    *ngIf=\"!feedbackSubmitted; else thankyou\"\n  >\n    <ng-container *ngSwitchCase=\"'STAR'\">\n      <app-star-feedback-widget></app-star-feedback-widget>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"'SMILEY'\">\n      <app-smiley-feedback-widget></app-smiley-feedback-widget>\n    </ng-container>\n  </ng-container>\n  <ng-template #thankyou>\n    <lib-feedback-widget-thankyou></lib-feedback-widget-thankyou>\n  </ng-template>\n</div>\n", styles: [":host .feedback-widget-container{position:fixed;z-index:99999999;background:rgba(0,0,0,.5);width:100%;height:100%;top:0;left:0;bottom:0;right:0}:host ::ng-deep .fw-dialog-container{background:#ffffff;border-radius:3px 3px 0 0;padding:40px;box-sizing:border-box;overflow:auto;position:absolute;left:50%;top:50%;transform:translate(-50%,-50%)}\n"], components: [{ type: StarFeedbackWidgetComponent, selector: "app-star-feedback-widget" }, { type: SmileyFeedbackWidgetComponent, selector: "app-smiley-feedback-widget" }, { type: FeedbackWidgetThankyouComponent, selector: "lib-feedback-widget-thankyou" }], directives: [{ type: i5__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5__namespace.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i5__namespace.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }] });
    __decorate([
        validateAgainst(isTypeOf("string"))
    ], DpwFeedbackWidgetComponent.prototype, "width", void 0);
    __decorate([
        validateAgainst(isTypeOf("string"))
    ], DpwFeedbackWidgetComponent.prototype, "height", void 0);
    __decorate([
        validateAgainst(isTypeOf("string"))
    ], DpwFeedbackWidgetComponent.prototype, "widgetName", void 0);
    __decorate([
        validateAgainst(isTypeOf("string"))
    ], DpwFeedbackWidgetComponent.prototype, "productName", void 0);
    __decorate([
        isRequired("string", 100)
    ], DpwFeedbackWidgetComponent.prototype, "heading", void 0);
    __decorate([
        isRequired("string", 200)
    ], DpwFeedbackWidgetComponent.prototype, "description", void 0);
    __decorate([
        isRequired("string")
    ], DpwFeedbackWidgetComponent.prototype, "ratingStyle", void 0);
    __decorate([
        validateAgainst(isTypeOf("string"))
    ], DpwFeedbackWidgetComponent.prototype, "userEmail", void 0);
    __decorate([
        isRequired("boolean")
    ], DpwFeedbackWidgetComponent.prototype, "isLoggedIn", void 0);
    __decorate([
        validateAgainst(isTypeOf("string"))
    ], DpwFeedbackWidgetComponent.prototype, "feedbackBtnText", void 0);
    __decorate([
        validateAgainst(isTypeOf("boolean"))
    ], DpwFeedbackWidgetComponent.prototype, "showClose", void 0);
    __decorate([
        isRequired("string", 100)
    ], DpwFeedbackWidgetComponent.prototype, "thankYouHeading", void 0);
    __decorate([
        isRequired("string", 200)
    ], DpwFeedbackWidgetComponent.prototype, "thankYouDescription", void 0);
    __decorate([
        validateAgainst(isTypeOf("string"))
    ], DpwFeedbackWidgetComponent.prototype, "thankYouBtnText", void 0);
    __decorate([
        validateAgainst(isTypeOf("boolean"))
    ], DpwFeedbackWidgetComponent.prototype, "enableProgressive", void 0);
    __decorate([
        validateAgainst(isTypeOf("array", 4))
    ], DpwFeedbackWidgetComponent.prototype, "progressiveChips", void 0);
    __decorate([
        validateAgainst(isTypeOf("string", 50))
    ], DpwFeedbackWidgetComponent.prototype, "badRatingHeader", void 0);
    __decorate([
        validateAgainst(isTypeOf("string", 50))
    ], DpwFeedbackWidgetComponent.prototype, "averageRatingHeader", void 0);
    __decorate([
        validateAgainst(isTypeOf("string", 50))
    ], DpwFeedbackWidgetComponent.prototype, "goodRatingHeader", void 0);
    __decorate([
        validateAgainst(isTypeOf("number"))
    ], DpwFeedbackWidgetComponent.prototype, "textareaLimit", void 0);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: DpwFeedbackWidgetComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: "dpw-feedback-widget",
                        templateUrl: "./dpw-feedback-widget.component.html",
                        styleUrls: ["./dpw-feedback-widget.component.scss"],
                    }]
            }], ctorParameters: function () { return [{ type: DpwFeedbackWidgetService }]; }, propDecorators: { width: [{
                    type: i0.Input
                }], height: [{
                    type: i0.Input
                }], widgetName: [{
                    type: i0.Input
                }], productName: [{
                    type: i0.Input
                }], heading: [{
                    type: i0.Input
                }], description: [{
                    type: i0.Input
                }], ratingStyle: [{
                    type: i0.Input
                }], userEmail: [{
                    type: i0.Input
                }], isLoggedIn: [{
                    type: i0.Input
                }], feedbackBtnText: [{
                    type: i0.Input
                }], showClose: [{
                    type: i0.Input
                }], thankYouHeading: [{
                    type: i0.Input
                }], thankYouDescription: [{
                    type: i0.Input
                }], thankYouBtnText: [{
                    type: i0.Input
                }], enableProgressive: [{
                    type: i0.Input
                }], progressiveChips: [{
                    type: i0.Input
                }], badRatingHeader: [{
                    type: i0.Input
                }], averageRatingHeader: [{
                    type: i0.Input
                }], goodRatingHeader: [{
                    type: i0.Input
                }], onClose: [{
                    type: i0.Output
                }], onSuccess: [{
                    type: i0.Output
                }], textareaLimit: [{
                    type: i0.Input
                }] } });

    var GlobalErrorHandler = /** @class */ (function () {
        function GlobalErrorHandler(fwService) {
            this.fwService = fwService;
        }
        GlobalErrorHandler.prototype.handleError = function (error) {
            this.fwService.hasError = true;
            throw new Error(error);
        };
        return GlobalErrorHandler;
    }());
    GlobalErrorHandler.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: GlobalErrorHandler, deps: [{ token: DpwFeedbackWidgetService }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    GlobalErrorHandler.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: GlobalErrorHandler });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: GlobalErrorHandler, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () { return [{ type: DpwFeedbackWidgetService }]; } });

    var DpwFeedbackWidgetModule = /** @class */ (function () {
        function DpwFeedbackWidgetModule() {
        }
        return DpwFeedbackWidgetModule;
    }());
    DpwFeedbackWidgetModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: DpwFeedbackWidgetModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    DpwFeedbackWidgetModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: DpwFeedbackWidgetModule, declarations: [DpwFeedbackWidgetComponent,
            StarFeedbackWidgetComponent,
            SmileyFeedbackWidgetComponent,
            FeedbackWidgetHeaderComponent,
            FeedbackWidgetFooterComponent,
            FeedbackWidgetThankyouComponent,
            ProgressiveRatingComponent], imports: [i5.CommonModule], exports: [DpwFeedbackWidgetComponent] });
    DpwFeedbackWidgetModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: DpwFeedbackWidgetModule, providers: [{ provide: i0.ErrorHandler, useClass: GlobalErrorHandler }], imports: [[i5.CommonModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: DpwFeedbackWidgetModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            DpwFeedbackWidgetComponent,
                            StarFeedbackWidgetComponent,
                            SmileyFeedbackWidgetComponent,
                            FeedbackWidgetHeaderComponent,
                            FeedbackWidgetFooterComponent,
                            FeedbackWidgetThankyouComponent,
                            ProgressiveRatingComponent,
                        ],
                        imports: [i5.CommonModule],
                        exports: [DpwFeedbackWidgetComponent],
                        providers: [{ provide: i0.ErrorHandler, useClass: GlobalErrorHandler }],
                    }]
            }] });

    /*
     * Public API Surface of dpw-feedback-widget
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.DpwFeedbackWidgetComponent = DpwFeedbackWidgetComponent;
    exports.DpwFeedbackWidgetModule = DpwFeedbackWidgetModule;
    exports.DpwFeedbackWidgetService = DpwFeedbackWidgetService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=dpw-feedback-widget.umd.js.map
